"""

 Linbot Configuration file
 Edit this file to your choosing.  This is just a regular Python module, so
 if you want to do something fancy with it, go right ahead. Just make sure
 that all variables are defined and have an appropriate value .

"""

##### The Navigation (menu) frame/page ############
NAVBAR_FILENAME    = 'navbar.html'
NAVBAR_BGCOLOR = 'white'
NAVBAR_TEXT = 'white'
NAVBAR_LINK = 'white'
NAVBAR_VLINK = 'white'
NAVBAR_ALINK = '#FF0000'
NAVBAR_HEADER_COLOR = '#CD0000'
NAVBAR_OPTION_COLOR = 'black'
NAVBAR_WIDTH = '150'
NAVBAR_PADDING = 4
NAVBAR_SPACING = 0


MAIN_FILENAME      = 'index.html'


BODY_BGCOLOR = 'white'
BODY_TEXT = 'black'
BODY_LINK = 'blue'
BODY_VLINK = '#CD0000'
BODY_ALINK = 'magenta'

TITLE_BGCOLOR = '#CFCFCF'
TITLE_COLOR = 'black'

########## Configuration for the Site Map ###########
SITE_MAP_FILENAME  = 'map.html'
SITE_MAP_TITLE     = 'Site Map'
SITE_MAP_LEVEL = 5 # How many levels deep to display the site map
SITE_MAP_FONTSIZE = "-1"
#SITE_MAP_IMAGE     = 'map.gif'
SITE_MAP_IMAGE     = None

########## Configuration for broken links page #########
BAD_LINKS_FILENAME = 'broken.html'
BAD_LINKS_TITLE    = 'Broken Links'
#BAD_LINKS_IMAGE    = 'broken.gif'
BAD_LINKS_IMAGE    = None
BAD_LINKS_LINK_COLOR = '#CCCC99'
BAD_LINKS_STATUS_COLOR = '#BBBBB0' 
BAD_LINKS_PARENT_HEADER_COLOR = 'EEEEE0'
BAD_LINKS_PARENT_COLOR = '#DDDDD0'
BAD_LINKS_AUTHOR_COLOR = BAD_LINKS_PARENT_COLOR

####### Configuration for the images page #########
IMAGE_FILENAME     = 'images.html'
IMAGE_TITLE        = 'Images'
#IMAGE_IMAGE        = 'images.gif'
IMAGE_IMAGE        = None
# number of columns in thumbnail image page
IMAGE_COLS=5
# width of thumbnail images
IMAGE_WIDTH=100
# height of thumbnail images
IMAGE_HEIGHT=100
IMAGE_BGCOLOR = '#EEEEE0'

######## What's Old page #############
OLD_URL_FILENAME   = 'old.html'
OLD_URL_TITLE      = "What's Old"
#OLD_URL_IMAGE      = 'old.gif'
OLD_URL_IMAGE      = None
# minimum age (in days) for a url to be considered old
OLD_URL_AGE = 30

######## What's New page #############
NEW_URL_FILENAME   = 'new.html'
NEW_URL_TITLE      = "What's New"
#NEW_URL_IMAGE      = 'new.gif'
NEW_URL_IMAGE      = None
# maximum age (in days) for a url to be considered new
NEW_URL_AGE = 7

# background color of header in 'What's Old' and 'What's New' pages
AGE_HEADER_COLOR = '#CCCC99'

# background color of links
AGE_LINK_COLOR = '#EEEEE0'

# background color of author field
AGE_AUTHOR_COLOR = AGE_LINK_COLOR

# background color of age field
AGE_DAYS_COLOR = '#DDDDD0'


######## No Titles Page ###########
NO_TITLES_FILENAME = 'notitles.html'
NO_TITLES_TITLE    = 'No Titles'
#NO_TITLES_IMAGE    = 'titles.gif'
NO_TITLES_IMAGE    = None
# list of pages with no titles.
NO_TITLES_HEADER_COLOR = '#CCCC99'
NO_TITLES_URL_COLOR = '#DDDDD0'
NO_TITLES_AUTHOR_COLOR = '#EEEEE0'

###### External Links Page ########
EXTERNAL_FILENAME  = 'extern.html'
EXTERNAL_TITLE     = 'External Links'
#EXTERNAL_IMAGE     = 'external.gif'
EXTERNAL_IMAGE     = None
EXTERNAL_FILENAME  = 'extern.html'

####### Problems Page ##########
PROBLEMS_TITLE     = 'Problems'
#PROBLEMS_IMAGE     = 'problems.gif'
PROBLEMS_IMAGE     = None
PROBLEMS_FILENAME  = 'problems.html'
PROBLEMS_AUTHOR_COLOR = '#CCCC99'
PROBLEMS_TYPE_COLOR = '#EEEEE0'
PROBLEMS_LINK_COLOR = '#DDDDD0'

NOT_CHECKED_TITLE    = 'Not Checked'
NOT_CHECKED_FILENAME = 'notchked.html'
#NOT_CHECKED_IMAGE    = 'notchked.gif'
NOT_CHECKED_IMAGE    = None
NOT_CHECKED_LINK_COLOR = '#CCCC99'
NOT_CHeCKED_AUTHOR_COLOR = '#DDDDD0' 
NOT_CHECKED_PARENT_HEADER_COLOR = 'EEEEE0'
NOT_CHECKED_PARENT_COLOR = '#DDDDD0'

LINBOT_IMAGE       = None

# url to logo (image) shown on all pages.  If you change this you will also
# want to change the LOGO_ALT option below
LOGO_HREF="http://home1.gte.net/marduk/linbot/linbot.gif"

# alternative text for the logo.
LOGO_ALT="Linbot"


# if this is true, linbot will consider external all links that do not start in 
# the same directory level as the base url.  For example, given
# linbot http://www.myhost.com/~me/
# 'http://www.myhost.com/~me/stuff/index.html' would be considered internal while
# 'http://www.myhost.com/index.html' would be considered external.
# The default is false (0). note this can be overriden with the -b command-line
# flag
BASE_URLS_ONLY=0

# This is a (Python) list of URLs that should not be explored.  This can also
# be passed to linbot via the -x command line switch.  Note this should be a
# VALID REGULAR EXPRESSION.
#EXCLUDED_URLS = ['http://home1.gte.net/marduk/linbot/']
EXCLUDED_URLS = []

# This is like EXLUDED_URLS, but YANKED_URLS are not checked at all.  Also
# you can use the -y command line switch.
# When using the below parameter, make sure that the regular expressions are
# contained in triple quotes (raw Python strings).  Regular expressions are
# case insensitive.
#YANKED_URLS = ['''.*\.jpg''',
#                '''.*\.tar\.gz''']
YANKED_URLS = []


# Normally linbot will check links to "external" sites at the top level to
# ensure that your pages don't refer to broken links that are not at your
# site. However, you may not want this.  Setting this option to 1 will cause
# linbot to not check external links.  Note a link that is part of the. This
# can also be set with the command-line -a switch
#
# EXCLUDED_URLS list is considered external
AVOID_EXTERNAL_LINKS = 0

# Currently, Linbot can checks http:, ftp:, and file:, schemes.  However, you may
# want to avoid certain schemes (such as file: or ftp:).  Remove the scheme
# from this list and Linbot will avoid it.  Avoided URLs are treated as external
# Default is to not avoid any.
# Examples:
#SCHEMES = ['http']
#SCHEMES = ['http','ftp']
SCHEMES = ['http','ftp','file']


# You can define proxies for the individual schemes above.  The PROXIES config
# variable is a python dictionary or 'None', for example:
# PROXIES = {'http':'http://localhost:3128'}
#PROXIES = {'http':'http://localhost:3128','ftp':'http://localhost:3128'}
PROXIES = None
# Note: according to the urllib documentation, you should also be able to set
# proxies according to your system's environment variables, for example:
# $ HTTP_PROXY='http://localhost:3128' ; export HTTP_PROXY # using Bourne Shell
# $ FTP_PROXY='http://localhost:3128' ; export FTP_PROXY
# proxies in the configuration take precedence over environment settings


# hostnames (for example, www.myhost.com) which are to be considered local to
# your site.  Note that by default, the base URL of your site is considered
# local.  This can also be passed via command-line (see documentation for details
#
# HOSTS = ['home1.gte.net','manson.ddns.org']
HOSTS = [] 

# Directory where files generated by linbot will be placed.  This can also be
# specified via the -o command-line flag.
OUTPUT_DIR = '.'

# When listing a broken link in it's published report, Linbot can either make the
# broken link 'active' or simply list the URL.  Most users will probably not
# want the broken link to be active.
ANCHOR_BAD_LINKS = 0

# Usually, Linbot will processs a URL and immediately move on to the next one.
# However, on some loaded systems, it may be more desirable to have Linbot wait
# a while between requests.  This option should be set to any non-negative number
# (in seconds).  This can also be set using the command-line -w <secs> flag.
WAIT_BETWEEN_REQUESTS = 0

SHOW_CONFIG_PAGE = 0


################## you shouldn't need to change anything below #################

__version__='0.7'
__author__='marduk (marduk@starship.skyport.net)'  
LINBOT_HOME='http://starship.skyport.net/crew/marduk/linbot/'
