#!/usr/local/bin/python

##  Copyright (C) 1998  marduk <marduk@starship.skyport.net>

##  This program is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or
##  (at your option) any later version.

##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.

##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


__version__='0.7'
__author__ = 'marduk (marduk@starship.skyport.net)'

USAGE='linbot [-x url]... [-y url]... [-b][-a][-o dir][-w sec] url [location]...'
PYTHON_VERSION=1.5 # not used right now
level = 0
explored = []
problem_db = {}
linkList = {}

import sys
import time
import string

start_time = time.ctime(time.time())

# importing the config.py file is a real problem if the user did not install
# the files EXACTLY the way I said to... or even using the frozen version is
# becoming a real bitch.  I will just have to tell them right out how to fix it.
try:
    sys.path = ['.'] + sys.path
    import config
except ImportError:
    sys.stdout.write('Please verify that PYTHONPATH knows where to find "config.py"\n')
    sys.exit(1)

import myUrlLib
Link=myUrlLib.Link

# myUrlLib will be looking for a 'config' module.  set it up here.
myUrlLib.config=config

CODES=myUrlLib.HTTP_STATUS_CODES

def parse_args():
    import getopt
    global URL
    try:
	optlist, args = getopt.getopt(sys.argv[1:],'x:y:ao:bw:')
    except getopt.error, reason:
	print reason
	print USAGE
	sys.exit(1)
    for flag,arg in optlist:
	if flag=='-x':
	    config.EXCLUDED_URLS.append(myUrlLib.urlformat(arg))
	elif flag=='-y':
	    config.YANKED_URLS.append(myUrlLib.urlformat(arg))
	elif flag=='-a':
	    config.AVOID_EXTERNAL_LINKS=1
	elif flag=='-o':
	    config.OUTPUT_DIR=arg
	elif flag=='-b':
	    config.BASE_URLS_ONLY=1
	elif flag=='-w':
	    config.WAIT_BETWEEN_REQUESTS=int(arg)

    if len(args)==0:
	print USAGE
	sys.exit(1)
    else: URL = args[0]
    config.HOSTS=args[1:]

def sort_by_age(a,b):
    """ sort helper for url's age.  a and b are urls in linkList """
    aage, bage = linkList[a].age, linkList[b].age
    if aage < bage:
	return -1
    if aage == bage:
	return sort_by_author(a,b)
    return 1

def sort_by_rev_age(a,b):
    aage, bage = linkList[a].age, linkList[b].age
    if aage > bage:
	return -1
    if aage == bage:
	return sort_by_author(a,b)
    return 1

def sort_by_author(a,b):
    aauthor,bauthor = `linkList[a].author`, `linkList[b].author`
    if aauthor < bauthor:
	return -1
    if aauthor == bauthor:
	return 0
    return 1

def open_file(filename):
    """ given filename (and config.OUTPUT_DIR) opens filename for writing and
    returns the file object """
    return open(config.OUTPUT_DIR + filename,'w')
    
def get_title(url):
    """ returns the title of a url if it is not None, else returns url
    note that this implies linkList[url] """
    link=linkList[url]
    if link.title is None:
	return url
    return link.title


def add_problem(type,link):
    """ add a problem to the 'problems' database.  Will not add external links"""
    if link.external: return
    global problem_db
    author = link.author
    if problem_db.has_key(author):
	problem_db[author].append((type,link))
    else:
	problem_db[author]=[(type,link)]

class Page:
    # this is a class which describes an HTML pointed to in the navbar
     def __init__(self,title,filename,function,image=None):
	self.title = title
	self.filename = filename
	self.function = function
	self.image = image

	
def doTopMain(title=''):
    """top part of html files in main frame prints to stdout"""
    print '<html>'
    print '<head><title>%s</title>' % title
    print '<link rel="stylesheet" type="text/css" href="linbot.css">'
    print '</head>'
    print '<body \
             text="%(BODY_TEXT)s" \
	     bgcolor="%(BODY_BGCOLOR)s" \
	     link="%(BODY_LINK)s" \
	     vlink="%(BODY_VLINK)s" \
	     alink="%(BODY_ALINK)s">' % vars(config)
    print '<p align=center>'
    print '<img src="%(LOGO_HREF)s" alt="%(LOGO_ALT)s">' % vars(config)
    print '<H1 align=center><a href="%s">%s</a></H1>' \
	  % (`base`, get_title(`base`))
    print '<TABLE width="100%%" bgcolor="%(TITLE_BGCOLOR)s">' \
	  % vars(config)
    print '<TR><TD align=left valign=center>',
    print '<FONT SIZE="+2" COLOR="%s"><strong>&nbsp;%s</strong></FONT>' \
	  % (config.TITLE_COLOR,title)
    print '</TD></TR>\n</TABLE>'
    print


def doBotMain():
    """ bottom part of html files in main frame"""
    print 
    print '<hr>'
    print '<p><em>Generated %s by <a target="_top" href="%s">Linbot %s</a></em>' \
	  % (start_time,config.LINBOT_HOME, __version__)
    print '</body>'
    print '</html>'


def main_index():
    fp = open_file(config.MAIN_FILENAME)
    sys.stdout=fp
    
    print '<html>'
    print '<head>'
    print '<title>Linbot report for "%s"</title>' % get_title(`base`)
    print '</head>'
    print '<frameset COLS="%s,*" border=0 framespacing=0>' \
	  % config.NAVBAR_WIDTH
    print '<frame name="navbar" src="%s" marginwidth=0 marginheight=0>' \
	  % config.NAVBAR_FILENAME
    print '<frame name="main" src="%s">' % config.SITE_MAP_FILENAME
    print '</frameset>'
    print '</html>'
    fp.close()


def nav_bar(pages):
    # navigation bar
    fp=open_file(config.NAVBAR_FILENAME)
    sys.stdout=fp
    print '<html>\n<head>'
    print '\t<title>navbar</title>'
    print '\t<base target="main">'
    print '</head>'
    print '<body bgcolor="%(NAVBAR_BGCOLOR)s" \
               text="%(NAVBAR_TEXT)s" \
	       link="%(NAVBAR_LINK)s" \
	       vlink="%(NAVBAR_VLINK)s" \
	       alink="%(NAVBAR_ALINK)s">' % vars(config)
    print '<div align=center>'
    print '<table width="100%%" cellpadding="%s" cellspacing="%s">' \
	  % (config.NAVBAR_PADDING, config.NAVBAR_SPACING)
    # title
    print '<tr><th bgcolor="%s" align=center valign=middle>' \
	  % config.NAVBAR_HEADER_COLOR,
    if config.LINBOT_IMAGE is None:
	print '<A TARGET="_top" HREF="%s">Linbot %s</A></th></tr>' \
	      % (config.LINBOT_HOME, __version__)
    else:
	print '<A TARGET="_top" HREF="%s"><IMG border=0 SRC="%s" alt="Linbot %s"></A></th></tr>' \
	      % (config.LINBOT_HOME, config.LINBOT_IMAGE, __version__)

    # 'buttons' pointing to each individual page
    for page in pages:
	print '<tr>'
	print '<th bgcolor="%s" align=center valign=middle>' \
	      %  config.NAVBAR_OPTION_COLOR,
	if page.image is None:
	    print '<strong><a href="%s">%s</a></td></tr></strong>' \
		  % (page.filename, page.title)
	else:
	    print '<a href="%s"><img border=0 src="%s" alt="%s"></a></td></tr>' \
		  % (page.filename, page.image, page.title)

	# create the file we just pointed to
	tmp = sys.stdout
	fp = open_file(page.filename)
	sys.stdout = fp
	doTopMain(page.title)
	apply(page.function)
	doBotMain()
	fp.close()
	sys.stdout = tmp
	
    print
    print '</table>'
    print '</div>'
    print '</body>'
    print '</html>'

    fp.close()

def explore(link, explored):
    """Recursively do a breadth-first traversal of the graph of links
    on the site.  Returns a list of HTML fragments that can be printed 
    to produce a site map."""

    global level
    if level>config.SITE_MAP_LEVEL: return []
    # XXX I assume an object without a .URL is something
    # uninteresting? --amk
    if not hasattr(link, 'URL'): return []

    level=level+1
    explored[ link.URL ] = 1
    to_explore = []
    L = ['<ul>']

    # We need to do a breadth-first traversal.  This requires two
    # steps for any given page.  First, we need to make a list of
    # links to be traversed; links that have already been explored can 
    # be ignored.
    
    for i in link.children:
        # Skip pages that have already been traversed
        if explored.has_key( i ): continue
	if (i in Link.badLinks) and not config.ANCHOR_BAD_LINKS:
	    L.append('<LI>%s' % i)
	else:
            to_explore.append(i)
        explored[ i ] = 1               # Mark the link as explored

    # Now we loop over the list of links; the traversal will not go to 
    # any pages that are marked as having already been traversed.
    for i in to_explore:
            child = linkList[i]
	    L.append('<LI><a href="%s">%s</a>' % (i, get_title(i)))
	    L = L + explore(child, explored)
            
    L.append( '</ul>' )
    level=level-1

    # If no sub-pages were traversed at all, just return an empty list 
    # to avoid redundant <UL>...</UL> pairs
    if len(L) == 2: return []

    return L
    
# site map
def site_map():	
    print '<FONT SIZE="%s">' % config.SITE_MAP_FONTSIZE
    print '<a href="%s">Starting Page' % (base,)
    L = explore(base, {})
    for i in L: print i
    print '</FONT>'

#bad links
def bad_links():
    print '<TABLE align=center width="75%" border=0 cellspacing=2>'
    for link in Link.badLinks:
	#print `linkList[link].parents`
	print '<TR><TD colspan=3>&nbsp;</TD></TR>'
	if config.ANCHOR_BAD_LINKS:
	    print '<TR bgcolor="%s"><TH align=right>Link</TH><TD colspan=2 align=left><A href="%s">%s</TD></TR>' \
		  % (config.BAD_LINKS_LINK_COLOR, link, link),
	else:
	    print '<TR bgcolor="%s"><TH align=right>Link</TH><TD colspan=2 align=left>%s</TD></TR>' \
		  % (config.BAD_LINKS_LINK_COLOR, link),
	status = str(linkList[link].status)
	if status in CODES.keys():
	    status = status + ": " + CODES[status]
	print '<TR bgcolor="%s"><TH align=right>Status</TH><TD colspan=2 align=left>%s</TD></TR>' \
	      % (config.BAD_LINKS_STATUS_COLOR,status)
	print '<TR><TH bgcolor="%s" align=right valign=top rowspan="%s">Parents</TH>' \
	      % (config.BAD_LINKS_PARENT_HEADER_COLOR, len(linkList[link].parents))
	parents = linkList[link].parents
	parents.sort(sort_by_author)
	for parent in parents:
	    #if parent!=linkList[link].parents[0]: print '<TR>'
	    print '<TD bgcolor="%s"><a href="%s">%s</a></TD>' \
		  % (config.BAD_LINKS_PARENT_COLOR,parent,get_title(parent)),
	    print '<TD align=center bgcolor="%s">%s</TD><TR>' \
		  % (config.BAD_LINKS_AUTHOR_COLOR,str(linkList[parent].author))
	    add_problem("Bad Link: " + link,linkList[parent])
    print '</TABLE>'


# images
def images():    
    import math
    imagelist=Link.images

    currentPic=0
    rows = int(math.ceil(len(imagelist)/config.IMAGE_COLS))+1
    print '<TABLE border=0>'
    
    for row in range(rows):
	print'<TR>'
	for col in range(config.IMAGE_COLS):
	    if currentPic==len(imagelist): break
	    image=imagelist[currentPic]
	    print '\t<td bgcolor="%s"><a href="%s">' \
		  % (config.IMAGE_BGCOLOR,image)
	    print '<img src="%s" width="%d" height="%d" alt="%s"></A></TD>' \
		  % (image,config.IMAGE_WIDTH,config.IMAGE_HEIGHT, image)
	    currentPic = currentPic + 1

	print '</tr>'
    print '</table>\n\n</body>\n</html>'

# what's new
def whats_new():
    print '<TABLE align=center border=0 cellpadding=2 cellspacing=2 width="75%">'
    print '<TR bgcolor="%s"><TH align=center>Link</TH>' % config.AGE_HEADER_COLOR,
    print '<TH align=center>Author</TH>',
    print '<TH align=center>Age</TH></TR>'
    urls = linkList.keys()
    urls.sort(sort_by_age)
    for url in urls:
	link=linkList[url]
	age = link.age
	if (age is not None)and (age <= config.NEW_URL_AGE):
	    print '<TR><TD bgcolor="%s"><a href="%s">%s</a></TD>' \
		  % (config.AGE_LINK_COLOR, url, get_title(url)),
	    print '<TD align=center bgcolor="%s">%s</TD>' \
		  % (config.AGE_AUTHOR_COLOR, str(link.author)),
	    print '<TD align=center bgcolor="%s">%s</TD></TR>' % \
		  (config.AGE_DAYS_COLOR, str(age))
    print '</TABLE>'

# what's old
def whats_old():
    print '<TABLE align=center border=0 cellpadding=2 cellspacing=2 width="75%">'
    print '<TR bgcolor="%s"><TH align=center>Link</TH>' % config.AGE_HEADER_COLOR,
    print '<TH align=center>Author</TH>',
    print '<TH align=center>Age</TH></TR>'
    urls = linkList.keys()
    urls.sort(sort_by_rev_age)
    for url in urls:
	link=linkList[url]
	age = link.age
	if age and (age >= config.OLD_URL_AGE):
	    print '<TR><TD bgcolor="%s"><a href="%s">%s</a></TD>' \
		  % (config.AGE_LINK_COLOR, url, get_title(url)),
	    print '<TD align=center bgcolor="%s">%s</TD>' \
		  % (config.AGE_AUTHOR_COLOR, str(link.author)),
	    print '<TD align=center bgcolor="%s">%s</TD></TR>' \
		  % (config.AGE_DAYS_COLOR, `age`)
	    add_problem('Old Link: %s days' % age ,link)
    print '</TABLE>'

# pages with no titles
def no_titles():
    print '<TABLE align=center border=0 cellpadding=2 cellspacing=2 width="75%">'
    print '<TR bgcolor="%s">' % config.NO_TITLES_HEADER_COLOR,
    print '<TH align=center>URL</TH><TH align=center>Author</TH></TR>'
    urls = linkList.keys()
    urls.sort(sort_by_author)
    for url in urls:
	link = linkList[url]
	if link.external: continue
	if link.html and (link.title is None):
	    print '<TR><TD bgcolor="%s"><A HREF="%s">%s</A></TD>' \
		  % (config.NO_TITLES_URL_COLOR,url,url)
	    print '<TD align=center bgcolor="%s">%s</TD></TR>' \
		     % (config.NO_TITLES_AUTHOR_COLOR,str(link.author))
	    add_problem("No Title",link)
    print '</TABLE>'
	
# pages which were not checked
def not_checked():
    print '<DIV class="notchecked">'
    print '<TABLE align=center border=0 cellpadding=2 cellspacing=2 width="75%">'
    for url in Link.notChecked:
	print '<TR>'
	print '\t<TH colspan=4 bgcolor="%s"><a href="%s">%s</A></TH>' % \
	      (config.NOT_CHECKED_LINK_COLOR, url, url)
	print '<TR>\t<TH bgcolor="%s" rowspan="%s">Parent</TH>' % \
	      (config.NOT_CHECKED_PARENT_HEADER_COLOR, len(linkList[url].parents))
	for parent in linkList[url].parents:
	    if parent != linkList[url].parents[0]: print '<TR>',
	    print '\t<TD colspan=2 bgcolor="%s"><A href="%s">%s</A></TD>' % \
		  (config.NOT_CHECKED_PARENT_COLOR, parent, get_title(parent))
	    print '\t<TD bgcolor="%s">%s</TD>' % \
		  (config.NOT_CHeCKED_AUTHOR_COLOR,linkList[parent].author)
	print '<TR><TD colspan=4>&nbsp;</TD>'
    print '</TABLE>'
    print '</DIV>'


# external links
def external():
    print '<OL>'
    for url in linkList.keys():
	link=linkList[url]
	external = link.external
	if external:
	    print '\t<LI><A href="%s">%s</A>' % (url, get_title(url))
    print '</OL>'

# breakdown of links with problems
# the format of the Problems page really needs a face lift.  I am *very* open to
# suggestions.
def problems():
    authors=problem_db.keys()
    authors.sort()
    for author in authors:
	print '<TABLE align=center border=0 cellpadding=2 cellspacing=2 width="75%">'
	print '<TR><TH bgcolor="%s" colspan=2 align=center>%s</TH></TR>' \
	      % (config.PROBLEMS_AUTHOR_COLOR,author)
	for type,link in problem_db[author]:
	    url=`link`
	    title=get_title(url)
	    print '<TR><TD bgcolor="%s" align=left>%s</TD>' \
		  % (config.PROBLEMS_TYPE_COLOR,type),
	    print '<TD bgcolor="%s" align=left><A HREF="%s">%s</A></TD></TR>' \
		  % (config.PROBLEMS_LINK_COLOR,url,title)
	print '</TABLE>'

# configuration options
def config_page():
    print '<TABLE width="75%" align=center border=0 cellpadding=2 cellspacing=2>'
    print '<TR align=center valign=middle">'
    print '<TH>Name</TH><TH>Value</TH>'
    variables = vars(config)
    sorted=variables.keys()
    sorted.sort()
    for variable in sorted:
	if variable[:2]=="__": continue # don't show special variables
	print '<TR>'
	print '<TD bgcolor="%s" align=left valign=middle>' \
	      %  (config.TITLE_BGCOLOR),
	print '%s</TD>' % variable,
	print '<TD bgcolor="%s" align=left valign=middle>' \
	      %  (config.TITLE_BGCOLOR),
	print '%s</TD>' % str(variables[variable]),
	print '</TR>'
    print '<TD bgcolor="%s" align=left valign=middle>' \
	  %  (config.TITLE_BGCOLOR),
    print 'Command</TD>',
    print '<TD bgcolor="%s" align=left valign=middle>' \
	  %  (config.TITLE_BGCOLOR),
    print '%s' % string.join(sys.argv)
    print '</TABLE>'

def get_version(): # broken... DO NOT USE
    import string
    version = string.split(sys.version)[0]
    return eval(version)


if __name__=='__main__':

    # make sure we are running correct version of python
    # get_version() is broken (it doesn't work for, say 1.5.1) so we will
    # for now just skip version checking.
##     if get_version() < PYTHON_VERSION:
## 	sys.stderr.write("Linbot must be run using Python %s or better\n" \
## 			 % PYTHON_VERSION)
## 	sys.exit(1)

    parse_args()
    
    config.OUTPUT_DIR=config.OUTPUT_DIR + '/'

    
    print 'checking site....'
    base=myUrlLib.Link(URL,None) # this will take a while
    print 'done.'

    linkList = Link.linkList

    # now we can write out the files
    # start with the frame-description page
    main_index()
    
    # set up the pages
    pages = []
    pages.append(Page(config.SITE_MAP_TITLE,
		      config.SITE_MAP_FILENAME,
		      site_map,
		      config.SITE_MAP_IMAGE))
    pages.append(Page(config.BAD_LINKS_TITLE,
		      config.BAD_LINKS_FILENAME,
		      bad_links,
		      config.BAD_LINKS_IMAGE))
    pages.append(Page(config.IMAGE_TITLE,
		      config.IMAGE_FILENAME,
		      images,
		      config.IMAGE_IMAGE))
    pages.append(Page(config.OLD_URL_TITLE,
		      config.OLD_URL_FILENAME,
		      whats_old,
		      config.OLD_URL_IMAGE))
    pages.append(Page(config.NEW_URL_TITLE,
		      config.NEW_URL_FILENAME,
		      whats_new,
		      config.NEW_URL_IMAGE))
    pages.append(Page(config.NO_TITLES_TITLE,
		      config.NO_TITLES_FILENAME,
		      no_titles,
		      config.NO_TITLES_IMAGE))
    pages.append(Page(config.EXTERNAL_TITLE,
		      config.EXTERNAL_FILENAME,
		      external,
		      config.EXTERNAL_IMAGE))
    pages.append(Page(config.NOT_CHECKED_TITLE,
		      config.NOT_CHECKED_FILENAME,
		      not_checked,
		      config.NOT_CHECKED_IMAGE))
    pages.append(Page(config.PROBLEMS_TITLE,
		      config.PROBLEMS_FILENAME,
		      problems,
		      config.PROBLEMS_IMAGE))
    if config.SHOW_CONFIG_PAGE:
	pages.append(Page(config.CONFIG_TITLE,
			  config.CONFIG_FILENAME,
			  config_page,
			  config.CONFIG_IMAGE))
    
    # create the navigation bar, which creates the pages it points to
    nav_bar(pages)









 

    

